VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "oNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'****************************************
'**   autor: A. Szarek, (c)2003, 2009  **
'**   admin@vbamania.pl                **
'**   odwied www.vbamania.pl          **
'****************************************

'W  oparciu o niniejszy modu klasy moliwe jest
'stworzenie obiektw bdcych wzami w grafie zwanym drzewem
'uytkownik moe tworzy i zmienia relacje pomidzy wzami

'Deklaracje zmiennych lokalnych, w ktrych bd
'przechowywane wartoci waciwoci

Private oNodeType As Long
Private oParent As oNode
Private oValue As String
Private oChildren As Collection
Private oType As num

Private Sub Class_Initialize()
    'konstruktor - procedura uruchamiana
    'w momencie tworzenia instacji klasy
    oValue = "": oKey = ""
    Set oChildren = New Collection
End Sub

Private Sub Class_Terminate()
    'destruktor - procedura uruchamiana
    'w momencie niszczenia instacji klasy
    Set oChildren = Nothing
End Sub

Public Sub RemoveChild(oC As oNode)

'Usuwanie dziecka
Dim el As oNode
Dim i As Long
i = 1

'przebiegamy po kolekcji potomkw obiektu
'i jeli obiekt bdcy argumentem procedury waciwoci
'jest w kolekcji potomkw obiektu to go usuwamy
For Each el In Children
    If el Is oC Then Children.Remove i: Exit For
    i = i + 1
Next el

End Sub

Friend Property Get Children() As Collection
   'Ustawienie referencji do kolekcji dzieci
   Set Children = oChildren
End Property

Friend Property Get Parent() As oNode
   'Waciwo zwracajca rodzica obiektu
   Set Parent = oParent
End Property

Property Set Parent(oC As oNode)
   'Metoda zmieniajca rodzica obiektu
   If Not oParent Is Nothing Then oParent.RemoveChild Me
   'ustawiamy nowego rodzica...
   Set oParent = oC
   '...i dodajemy obiekt do kolekcji potomkw.
   oC.Children.Add Me
End Property

Property Get Value() As String
   'Waciwo zwracajca warto obiektu
    Value = oValue
End Property

Property Let Value(strValue As String)
    'Waciwo ustawiajca warto obiektu
    oValue = strValue
End Property
Property Get NodeType() As Long
   'Waciwo zwracajca typ obiektu
    NodeType = oNodeType
End Property

Property Let NodeType(lngNodeType As Long)
    'Waciwo ustawiajca typ obiektu
    oNodeType = lngNodeType
End Property

Friend Function AddChild(strValue As String, lngType As Long) As oNode
    'Metoda dodajca do nowego potomka do
    'zbioru potomkw danego obiektu
    Dim oChild As oNode
    Set oChild = New oNode
    oChild.Value = strValue
    oChild.NodeType = lngType
    Set oChild.Parent = Me
    Set AddChild = oChild
    
End Function

Friend Property Get ChildrenCount() As Long
    'Waciwo zwracajca informacj o liczbie dzieci danego obiektu
    ChildrenCount = Me.Children.Count
End Property

Friend Property Get IsParent(oChild As oNode) As Boolean

'Waciwo zwracajca informacj, czy
'obiekt jest rodzicem obiektu danego jako argument
Dim oC As oNode

IsParent = False
For Each oC In Children
    If oC Is oChild Then
        IsParent = True
        Exit Property
    End If
Next oC

End Property

Friend Property Get IsChild(oParent As oNode) As Boolean
    'Waciwo zwracajca informacj, czy
    'obiekt jest potomkiem obiektu danego jako argument
    If Me.Parent Is oParent Then IsChild = True Else IsChild = False
End Property

Friend Property Get IsBrother(oC As oNode) As Boolean
    'Waciwo zwracajca informacj, czy
    'obiekt ma rodzestwo (czyli czy jego rodzic ma inne dzieci)
    If Me.Parent Is oC.Parent And Not Me Is oC Then IsBrother = True Else IsBrother = False
    
End Property

Friend Property Get IsRoot() As Boolean
    'Waciwo zwracajca informacj, czy
    'obiekt jest korzeniem (czy nie ma rodzica)
    If Me.Parent Is Nothing Then IsRoot = True Else IsRoot = False
End Property
